Whamcloud - gitweb
LU-1032 build: DKMS RPM for Lustre Client modules
[fs/lustre-release.git] / contrib / lbuild / lbuild
index 8c24402..09a634c 100755 (executable)
@@ -71,6 +71,7 @@ OSDLDISKFSRPM=true
 OSDZFSRPM=false
 SMPTYPES="smp bigsmp default ''"
 PATCHLESS=false
+WITH_ZFS=""
 XEN=false
 LINUXOBJ=
 DISTRO=
@@ -168,7 +169,7 @@ Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
     Path to an existing lustre source tarball to use.
 
   --nodownload
-    Do not try to download a kernel from downloads.lustre.org
+    Do not try to download a kernel from downloads.hpdd.intel.com
 
   --nosrc
     Do not build a .src.rpm, a full kernel patch, or a patched kernel
@@ -187,6 +188,9 @@ Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
     Specifies that the files generated do not include timestamps, and
     that this is an official release.
 
+  --disable-zfs
+    Build Lustre without ZFS.
+
   --src
     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
 
@@ -261,11 +265,10 @@ check_options() {
 
     if [ -z "$DISTRO" ] ; then
         DISTRO=$(autodetect_distro)
-        # remove minor version only for rhel and oel
-        [[ $DISTRO =~ "el-" ]] && DISTRO=${DISTRO%%.*}
         # remove separator
         DISTRO=${DISTRO/-/}
     fi
+    DISTROMAJ=${DISTRO%%.*}
 
     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
 
@@ -282,7 +285,13 @@ check_options() {
     fi
 
     case $TARGET in
-        2.6-rhel6)
+        3.12-sles12)
+            CANONICAL_TARGET="sles12"
+            ;;
+        3.10-rhel7)
+            CANONICAL_TARGET="rhel7"
+            ;;
+        2.6-rhel6*)
             CANONICAL_TARGET="rhel6"
             ;;
         2.6-rhel5)
@@ -429,7 +438,7 @@ download_srpm() {
     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
        [ ! -s "$KERNELDIR/$srpm" ]; then
         if $DOWNLOAD; then
-            local location="http://downloads.lustre.org/public/kernels/$target/old"
+            local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
             # get the location from a distro specific method if it exists
             if type -p kernel_srpm_location; then
                 location=$(kernel_srpm_location)
@@ -439,11 +448,11 @@ download_srpm() {
                [ ! -s "$KERNELDIR/$srpm" ]; then
                 rm -f $KERNELDIR/$srpm
                 # punt to a distro specific method if it exists
-                if ! type -p download_srpm-$DISTRO; then
+                if ! type -p download_srpm-$DISTROMAJ; then
                     fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
                 else
-                    if ! download_srpm-$DISTRO "$target" "$srpm" "$force"; then
-                        fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTRO."
+                    if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
+                        fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
                     fi
                 fi
             fi
@@ -550,17 +559,16 @@ download_ofed() {
     if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
         local Mmv
         Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
-        location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
+        location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
     fi
 
     if [[ $OFED_VERSION = daily-* ]]; then
-        local Mmv daily
-        OFED_VERSION=${OFED_VERSION/daily-/}
-        Mmv=${OFED_VERSION%%-*}
+        local Mmv
+        Mmv=${OFED_VERSION/daily-/}
         daily=${OFED_VERSION##$Mmv-}
-        location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
+        location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
         # find the filename for the version for the date specified
-        OFED_VERSION=$(curl -s "$location" | sed -nre "/${daily}-/s/.*href=\"OFED-(${Mmv//./\\.}-${daily}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
+        OFED_VERSION=$(curl -s "$location" | sed -nre "/${Mmv}-/s/.*href=\"OFED-(${Mmv}-[0-9]{8,8}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
         if [ -z "$OFED_VERSION" ]; then
             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
         fi
@@ -593,8 +601,12 @@ parse_mpss_info() {
     for url in $urls; do
         local ver2=""
         local ver3=""
+        # Try to match with MPSS 3.3 package
+        if [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-linux.tar ]]; then
+            ver3=${url##*mpss-}
+            ver3=${ver3%%-linux.tar}
         # Try to match with MPSS 3.x or 3.x.x distro package
-        if [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-$distro.tar ]]; then
+        elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-$distro.tar ]]; then
             ver3=${url##*mpss-}
             ver3=${ver3%%-$distro.tar}
         # Try to match with MPSS 3.x or 3.x.x source package
@@ -612,15 +624,10 @@ parse_mpss_info() {
         fi
 
         if [ -n "$ver3" ]; then
-            # Check for MPSS 3.x or MPSS 3.x.x
-            if [[ $ver3 =~ [0-9].[0-9].[0-9]* ]]; then
-                ver3="${ver3}-0"
-            else
-                ver3="${ver3}.0-0"
-            fi
+            ver3="${ver3}-0"
             if [ -z "$build" ]; then
                 res3="$ver3"
-            elif [ "$build" = "$ver3" ]; then
+            elif [ "${build%%-*}" = "${ver3%%-*}" ]; then
                 res3="$res3 $url"
             fi
         elif [ -n "$ver2" ]; then
@@ -641,24 +648,8 @@ parse_mpss_info() {
             echo "$res2"
         fi
     elif [ "${build%%.*}" = "3" ]; then
-        local ver=${build%%-*}
-        local bid=${build##*-}
-        if [ $bid -eq 0 ]; then
-            # return URLs from MPSS info file
-            echo "$res3"
-        else
-            # Check for MPSS 3.x or MPSS 3.x.x
-            if [ ${ver##*.} -eq 0 ]; then
-                ver=${ver%.*}
-            fi
-            # return URLs from internal site with MPSS builds
-            # kernel sources:
-            echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-src-$ver.tar"
-            # kernel configs:
-            echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-$ver-k1om.tar"
-            # OFED headers:
-            echo "${MPSS_BUILDS:-"http://mic-bld.pdx.intel.com/release"}/$ver/$bid/release/knightscorner/package/mpss-$ver-$distro.tar"
-        fi
+        # return URLs from MPSS info file
+        echo "$res3"
     else
         # return URLs from MPSS info file
         echo "$res2"
@@ -680,15 +671,12 @@ download_mpss() {
     local force="${2:-false}"
     local urls=$(parse_mpss_info "$file" ${MPSS_VERSION} ${MPSS_DISTRO})
 
-    [ -z "$urls" ] && fatal 1 "Could not determine the URLs of MPSS $MPSS_VERSION"
-
-    # force re-download if build number is zero
-    [[ $MPSS_VERSION = [0-9].[0-9].[0-9]*-0 ]] && force=true
+    [ -z "$urls" ] && return 0
 
     local url
     local i=0
     for url in $urls; do
-        file="$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part$i.tar"
+        file="$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part$i.tar"
         download_file "$url" "$file" "$force"
         i=$((i+1))
     done
@@ -725,7 +713,7 @@ load_target() {
     #       go away and the target just specify the $RPMSMPTYPE
     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
 
-    # CC might have been overwriten in TARGET_FILE
+    # CC might have been overwritten in TARGET_FILE
     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
         export CCACHE && export CC="ccache $CC"
     fi
@@ -797,18 +785,19 @@ load_target() {
 tarflags() {
     local file="$1"
 
+    echo -n '--wildcards '
     case "$file" in
         '')
             fatal 1 "tarflags(): File name argument missing."
             ;;
         *.tar.gz | *.tgz)
-            echo 'zxf'
+            echo '-zxf'
             ;;
         *.tar.bz2)
-            echo 'jxf'
+            echo '-jxf'
             ;;
         *.tar)
-            echo 'xf'
+            echo '-xf'
             ;;
         *)
             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
@@ -847,51 +836,51 @@ unpack_mpss() {
 
     [ -d mpss ] && return 0
 
-    if [ "${MPSS_VERSION%%.*}" = "3" ]; then
-        local ver=${MPSS_VERSION%%-*}
+    if [ "$MPSS_MAJ" = "3" ]; then
         local file
         local i
-        # Check for MPSS 3.x or MPSS 3.x.x
-        if [ ${ver##*.} -eq 0 ]; then
-            ver=${ver%.*}
-        fi
         for i in $(seq 0 9); do
-            file="$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part$i.tar"
+            file="$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part$i.tar"
             if [ -r "$file" ]; then
                 untar "$file" \
-                    "mpss-$ver/*/linux-*.tar.bz2" \
-                    "mpss-$ver/*/kernel-dev-*.rpm" \
-                    "mpss-$ver/*/ofed-driver-*-devel-*.rpm"
+                    "mpss-$MPSS_VER/*/linux-*.tar.bz2" \
+                    "mpss-$MPSS_VER/*/kernel-dev-*.rpm" \
+                    "mpss-$MPSS_VER/*/ofed-driver-devel-*.rpm" \
+                    "mpss-$MPSS_VER/*/ofed-driver-*-devel-*.rpm"
             fi
         done
         # Extract kernel configs
-        file=$(find mpss-$ver -type f -path "*/kernel-dev-*.rpm")
+        file=$(find mpss-$MPSS_VER -type f -path "*/kernel-dev-*.rpm" -print -quit)
         if ! rpm2cpio "$file" | cpio -idm; then
             echo "Error extracting MPSS kernel configs"
             return 1
         fi
         # Unpack kernel sources
-        file=$(find mpss-$ver -type f -path "*/linux-*.tar.bz2")
+        file=$(find mpss-$MPSS_VER -type f -path "*/linux-*.tar.bz2" -print -quit)
         if ! untar "$file"; then
             echo "Error unpacking MPSS kernel sources"
             return 1
         fi
         # Extract OFED headers
-        file=$(find mpss-$ver -type f -path "*/ofed-driver-*-devel-*.rpm")
+        file=$(find mpss-$MPSS_VER -type f -path "*/ofed-driver-*-devel-*.rpm" -print -quit)
         if ! rpm2cpio "$file" | cpio -idm; then
-            echo "Error extracting MPSS OFED headers"
-            return 1
+            # Name was changed in MPSS 3.3
+            file=$(find mpss-$MPSS_VER -type f -path "*/ofed-driver-devel-*.rpm" -print -quit)
+            if ! rpm2cpio "$file" | cpio -idm; then
+                echo "Error extracting MPSS OFED headers"
+                return 1
+            fi
         fi
         # Remove unpacked archives to save space
-        rm -rf mpss-$ver
+        rm -rf mpss-$MPSS_VER
         # Make link to MPSS kernel sources
         ln -sf linux-* mpss
     else
-        local dir="mpss-${MPSS_VERSION}-${MPSS_DISTRO%%-*}"
+        local dir="mpss-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO%%-*}"
 
         mkdir $dir || return 255
         pushd $dir >/dev/null || return 255
-        if ! untar "$KERNELTREE/mpss_src-${MPSS_VERSION}-${MPSS_DISTRO}-part0.tar" "*/gpl/*full_src*"; then
+        if ! untar "$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part0.tar" "*/gpl/*full_src*"; then
             popd >/dev/null
             rm -rf $dir
             echo "Error unpacking MPSS tarball 1"
@@ -966,12 +955,6 @@ build_lustre() {
         targets="--target $arch $targets"
     done
 
-    local confoptions=""
-
-    if $PATCHLESS; then
-        confoptions="$confoptions --disable-server"
-    fi
-
     local rpmbuildopt='-tb'
     if $NORPM; then
         rpmbuildopt='-tc'
@@ -982,7 +965,7 @@ build_lustre() {
     # These are required prior to the building of lustre server. Client does
     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
     # line above so is at least consistant.
-    if [ $PATCHLESS == false ] && [ "x$ZFSNOTSUPPORTED" == "x" ]; then
+    if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
         if ! build_spl_zfs; then
             popd >/dev/null # pushd lustre
             return 255
@@ -1016,7 +999,7 @@ build_lustre() {
     fi
 
     RPMBUILD_DEFS="$RPMBUILD_DEFS ${FIND_REQUIRES:+--define \"__find_requires $FIND_REQUIRES\"}"
-    RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args $confoptions ${CONFIGURE_FLAGS}\""
+    RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args ${CONFIGURE_FLAGS}\""
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kdir $linux\""
     RPMBUILD_DEFS="$RPMBUILD_DEFS ${linuxobj:+--define \"kobjdir $linuxobj\"}"
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_tmppath $TMPDIR\""
@@ -1037,13 +1020,20 @@ build_lustre() {
 
 }
 
+# Only zfs Lustre DKMS Server is supported
 build_lustre_dkms() {
     [ -n "$MPSS_VERSION" ] && return 0
     local ver=$(eval echo  $(awk '/LUSTRE_VERSION_STRING/ {print $3}'  lustre/include/lustre_ver.h))
     echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
     ./configure --enable-dist || return 255
-    $RPMBUILD --define="_topdir $TOPDIR" -bs lustre-dkms.spec || return 255
-    $RPMBUILD --rebuild --define="_topdir $TOPDIR" $TOPDIR/SRPMS/lustre-dkms-$ver-*.src.rpm || return 255
+
+    if $PATCHLESS; then
+       $RPMBUILD --define="_topdir $TOPDIR" --without servers -bs lustre-dkms.spec || return 255
+        $RPMBUILD --rebuild --define="_topdir $TOPDIR" --without servers $TOPDIR/SRPMS/lustre-client-dkms-$ver-*.src.rpm || return 255
+    else
+       $RPMBUILD --define="_topdir $TOPDIR" -bs lustre-dkms.spec || return 255
+        $RPMBUILD --rebuild --define="_topdir $TOPDIR" $TOPDIR/SRPMS/lustre-dkms-$ver-*.src.rpm || return 255
+    fi
     return 0
 }
 
@@ -1067,7 +1057,7 @@ build_spl_zfs() {
     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
     # destination for the rpms
     export RPM_BUILD_ROOT=$TOPDIR
-    SPLZFSVER=${SPLZFSVER:-0.6.3}
+    SPLZFSVER=${SPLZFSVER:-0.6.5.2}
     SPLZFSTAG=${SPLZFSTAG:-}
 
     # The files expect a kver to be set to the kernel version .
@@ -1186,7 +1176,7 @@ build_spl_zfs() {
 prepare_mpss() {
 
     pushd mpss >/dev/null || return 255
-    if [ "${MPSS_VERSION%%.*}" = "3" ]; then
+    if [ "$MPSS_MAJ" = "3" ]; then
         cp -f ../boot/config-* .config
         if ! make ARCH=k1om silentoldconfig ; then
             popd >/dev/null
@@ -1295,8 +1285,8 @@ unpack_linux_devel_rpm() {
     fi
 
     # call a distro specific hook, if available
-    if type -p unpack_linux_devel_rpm-$DISTRO; then
-        if ! unpack_linux_devel_rpm-$DISTRO "$kernelrpm"; then
+    if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
+        if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
             return 255
         fi
     fi
@@ -1321,13 +1311,13 @@ build_kernel_ib() {
         K_SRC="KSRC"
     fi
 
-    local OFED_CORE="--with-core-mod --with-ipoib-mod --with-sdp-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
-    local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod"
+    local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
+    local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod --with-qib-mod"
 
     if compare_version $OFED_VERSION 3.0; then
        OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
     else
-       OFED_HARDWARE="$OFED_HARDWARE --with-cxgb4-mod"
+       OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
     fi
 
     # some I/B drivers are architecture dependent and kernel-ib's configure
@@ -1558,8 +1548,11 @@ build_kernel_with_srpm() {
     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
         local REUSE_SIGNATURE=$({ echo -en $release_str;
                                   echo $BUILD_GEN;
-                                  cat $CONFIG_FILE $TARGET_FILE $FULL_PATCH;
-                                  cat $LBUILD_DIR/lbuild $LBUILD_DIR/lbuild-${DISTRO}; } |
+                                  cat "$CONFIG_FILE";
+                                  cat "$TARGET_FILE";
+                                  cat "$FULL_PATCH";
+                                  cat "$LBUILD_DIR/lbuild";
+                                  cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
                                 md5sum | cut -d" " -f1)
         # see if we can link to the reuse pool
         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
@@ -1653,9 +1646,9 @@ build_ofed() {
         # XXX we need to better integrate a distro specific override with
         #     the rest of this function so that all of the reuse cache
         #     stuff is leveraged given that 80% of this function is reuse
-        if type -p build_ofed-${DISTRO}; then
+        if type -p build_ofed-$DISTROMAJ; then
             local ofed_location
-            ofed_location=$(build_ofed-${DISTRO} ${STDOUT})
+            ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
             local rc=${PIPESTATUS[0]}
             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
             return $rc
@@ -1676,8 +1669,8 @@ build_ofed() {
                                   echo "$(find_linux_release;
                                   echo "$BUILD_GEN")";
                                   cat "${linux}/include/linux/autoconf.h";
-                                  cat "$LBUILD_DIR/lbuild" ;
-                                  cat "$LBUILD_DIR/lbuild-${DISTRO}"; } |
+                                  cat "$LBUILD_DIR/lbuild";
+                                  cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
                                 md5sum | cut -d" " -f1)
         # see if we can link to the reuse pool
         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
@@ -1777,7 +1770,7 @@ build_with_srpm() {
         # client build
         local kernelrpm
         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
-            fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in ${KERNELRPMSBASE}/${lnxmaj}/${DISTRO}"
+            fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
         fi
         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
             fatal 1 "Could not find the Linux tree in $kernelrpm"
@@ -1977,7 +1970,7 @@ set -E
 
 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
 
-options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,mpss-version:,publish,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
+options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,mpss-version:,publish,disable-zfs,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
 
 if [ $? != 0 ]; then
     usage 1
@@ -2082,6 +2075,10 @@ while [ "$1" ]; do
         --publish)
             shift
             ;;
+       --disable-zfs)
+           WITH_ZFS="no"
+           shift
+           ;;
         --release)
             RELEASE=true
             shift
@@ -2132,8 +2129,7 @@ unpack_lustre
 
 # XXX - should we _always_ get the buildid from the META file?  what are the
 # other (i.e. non-lustre-tarball use cases of lbuild)?
-BUILDID=$(sed -ne '/^BUILDID =/s/.*= *//p' lustre/META)
-VERSION=$(sed -ne '/^VERSION =/s/.*= *//p' lustre/META)
+BUILDID=$(sed -n -e 's/^BUILDID = //p' lustre/META)
 
 load_target
 
@@ -2150,19 +2146,23 @@ if [ -n "$MPSS_VERSION" ]; then
 
     if [ "$MPSS_VERSION" = "last" ]; then
         MPSS_VERSION=$(parse_mpss_info "$MPSS_INFO" "" ${MPSS_DISTRO})
-        [ -z "$MPSS_VERSION" ] && fatal 1 "Could not determine the last MPSS version"
-    elif [[ $MPSS_VERSION != [0-9].[0-9].[0-9]*-[0-9]* ]]; then
-        fatal 1 "Incorrect MPSS version $MPSS_VERSION"
+        [ -z "$MPSS_VERSION" ] &&
+            fatal 1 "Could not determine the last MPSS version"
     fi
 
+    MPSS_MAJ=${MPSS_VERSION%%.*}
+    MPSS_VER=${MPSS_VERSION%%-*}
+    MPSS_BLD=${MPSS_VERSION##*-}
+    [ "$MPSS_VER" = "$MPSS_BLD" ] && MPSS_BLD=0
+
     download_mpss "$MPSS_INFO"
     [ -r "$MPSS_INFO" ] && rm -f "$MPSS_INFO"
-    echo "Building with MPSS $MPSS_VERSION"
+    echo "Building with MPSS $MPSS_VER-$MPSS_BLD"
     unpack_mpss  || fatal 1 "Error unpacking MPSS tarballs"
     prepare_mpss || fatal 1 "Error preparing MPSS for kernel modules build"
 
     if [ -z "$MPSS_OFED" ]; then
-        MPSS_OFED=$(find $PWD -type f -path "*/ofed-driver-*/Module.symvers")
+        MPSS_OFED=$(find $PWD -type f -path "*/ofed-driver*/Module.symvers" -print -quit)
         if [ -n "$MPSS_OFED" ]; then
             MPSS_OFED="--with-o2ib=$(dirname $MPSS_OFED)"
         else
@@ -2174,22 +2174,24 @@ if [ -n "$MPSS_VERSION" ]; then
     PATCHLESS=true
     IOKITRPM=false
     LDISKFSRPM=false
-    ZFSNOTSUPPORTED="yes"
+    WITH_ZFS="no"
 
     # define variables for cross compilation:
     CROSS_SUFFIX="-mic"
-    if [ "${MPSS_VERSION%%.*}" = "3" ]; then
+    if [ "$MPSS_MAJ" = "3" ]; then
         CC_TARGET_ARCH=k1om-mpss-linux
         LINUX="$TOPDIR/mpss"
+        RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires /bin/sh\""
     else
         CC_TARGET_ARCH=x86_64-k1om-linux
         LINUX="$TOPDIR/mpss/card/kernel"
-        RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires intel-mic-gpl = ${MPSS_VERSION%%-*}\""
+        RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires intel-mic-gpl = $MPSS_VER\""
     fi
+    LUSTRE_VERSION=$(sed -n -e 's/^VERSION = //p' lustre/META)
     CONFIGURE_FLAGS="$CONFIGURE_FLAGS $MPSS_OFED --host=$CC_TARGET_ARCH --build=x86_64-pc-linux"
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"post_script build/gen_filelist.sh\""
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"make_args ARCH=k1om CROSS_COMPILE=${CC_TARGET_ARCH}-\""
-    RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_path ${CROSS_PATH:=/opt/lustre/${VERSION}/${CC_TARGET_ARCH}}\""
+    RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_path ${CROSS_PATH:=/opt/lustre/${LUSTRE_VERSION}/${CC_TARGET_ARCH}}\""
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"rootdir %{cross_path}\""
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_prefix %{cross_path}/usr\""
     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_mandir %{_prefix}/share/man\""
@@ -2213,10 +2215,10 @@ if [ -n "$LINUX" ]; then
         fatal 1 "error building OFED"
     build_lustre "$LINUX" "$LINUXOBJ"
 else
-    if [ ! -f "${LBUILD_DIR}/lbuild-$DISTRO" ]; then
-        fatal 1 "${LBUILD_DIR}/lbuild-$DISTRO not found"
+    if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
+        fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
     fi
-    source ${LBUILD_DIR}/lbuild-$DISTRO
+    source ${LBUILD_DIR}/lbuild-$DISTROMAJ
     build_with_srpm || fatal 1 "Failed to build_with_srpm"
 fi